# Python Language Services

Python provides a number of modules to assist in working with the Python language. These modules support tokenizing, parsing, syntax analysis, bytecode disassembly, and various other facilities.

These modules include:

- `parser` --- Access Python parse trees
  - Creating ST Objects
  - Converting ST Objects
  - Queries on ST Objects
  - Exceptions and Error Handling
  - ST Objects
  - Example: Emulation of `compile()`
- `ast` --- 抽象语法树
  - 节点类
  - Abstract Grammar
  - `ast` Helpers
- `symtable` --- Access to the compiler's symbol tables
  - Generating Symbol Tables
  - Examining Symbol Tables
- `symbol` --- Constants used with Python parse trees
- `token` --- Constants used with Python parse trees
- `keyword` --- Testing for Python keywords
- `tokenize` --- Tokenizer for Python source
  - Tokenizing Input
  - Command-Line Usage
  - 示例
- `tabnanny` --- Detection of ambiguous indentation
- `pyclbr` --- Python class browser support
  - Function Objects
  - 类对象
- `py_compile` --- Compile Python source files
- `compileall` --- Byte-compile Python libraries
  - Command-line use
  - Public functions
- `dis` --- Python 字节码反汇编器
  - Bytecode analysis
  - Analysis functions
  - Python Bytecode Instructions
  - Opcode collections
- `pickletools` --- Tools for pickle developers
  - Command line usage
    - Command line options
  - Programmatic Interface